org &8000



di
defb &ed, &ff
call plus_unlock

ld b,&f5
l1:
in a,(c)
rra
jr nc,l1

ld bc,&7fb8
out (c),c
ld a,10
ld (&6800),a
ld bc,&7fa0
out (c),c

im 1
ld a,&c3
ld (&0038),a
ld hl,top
ld (&0039),hl
ei

mainloop:
jp mainloop

top:
push de
push hl
push bc
push af
ld bc,&7fb8
out (c),c
call raster_top
ld a,190
ld (&6800),a
ld hl,bottom
ld (&0039),hl
ld bc,&7fa0
out (c),c
pop af
pop bc
pop hl
pop de
ei
reti

bottom:
push de
push hl
push bc
push af
defs 16
ld bc,&7fb8
out (c),c
call raster_bottom
ld a,10
ld (&6800),a
ld hl,top
ld (&0039),hl
ld bc,&7fa0
out (c),c

pop af
pop bc
pop hl
pop de
ei
reti


ncolbytes equ end_raster_cols-raster_cols
ncols equ ncolbytes/2


raster_top:
ld de,raster_cols
ld hl,&6400
ld b,ncols
rt1:
ld a,(de)   ;; [2]
ld (hl),a   ;; [2]
inc l   ;; [1]
inc de ;; [2]
ld a,(de) ;; [2]
ld (hl),a ;; [2]
dec l ;; [1]
inc de ;; [2]
;; 14
;; 50
ld a,11
rt2:
dec a			;; [1]	
jp nz,rt2		;; [3]
dec b
jp nz,rt1
ret


raster_bottom:
ld de,end_raster_cols-2
ld hl,&6400
ld b,ncols
rb1:
ld a,(de)   ;; [2]
ld (hl),a   ;; [2]
inc l   ;; [1]
dec de ;; [2]
ld a,(de) ;; [2]
ld (hl),a ;; [2]
dec l ;; [1]
dec de ;; [2]
;; 14
;; 50
ld a,11
rb2:
dec a			;; [1]	
jp nz,rb2		;; [3]
dec b
jp nz,rb1
ret






raster_cols:
defw &000
defw &111
defw &222
defw &333
defw &444
defw &555
defw &666
end_raster_cols:



plus_unlock:
ld hl,plus_sequence
ld bc,&0bc00+15
pu1:
ld a,(hl)
out (c),a
inc hl
dec c
jr nz,pu1
ld a,&cd
out (c),a
ld a,&ee
out (c),a
ret
plus_sequence:
defb &ff, &0
defb &ff,&77,&b3,&51,&a8,&d4,&62,&39,&9c,&46,&2b,&15,&8a

;; detect plus
detect_plus:
  ld    bc,&f782
  out    (c),c
  dec    b
  ld    a,&f
  out    (c),a
  inc    b
  out    (c),c
  dec    b
  in    c,(c)
  cp    c 
  ret    
  