;; FILE: crt0.s
;; Generic crt0.s for a Z80
;; From SDCC..
;; Modified to suit execution on the Amstrad CPC!
;; by H. Hansen 2003
;; Original lines has been marked out!

    .module hexa_crt0
	.globl	_main
	.globl	_plus

	.area _HOME
	.area _CODE
	.area _GSINIT
	.area _GSFINAL
	.area _INITIALIZER
	.area _DATA
	.area _DATAFINAL
	.area _BSS
	.area _HEAP
	
.area _CODE
init::
	ld (_plus),a
         ;; Clear global variables
           ld      hl, #_datastart
           ld      bc, #_dataend
   _clear_loop:
           ld      a, h
           sub     b
           jr      nz, _clear_next
           ld      a, l
           sub     c
           jr      z, _clear_exit
   _clear_next:
           ld      (hl), #0
           inc     hl
           jr      _clear_loop
  _clear_exit:    
  di
  ld sp,#0x0000
	call    gsinit
	jp _main

		.area   _GSINIT
gsinit::
;; newer sdcc doesn't have this
	ld	bc, #l__INITIALIZER
	ld	a, b
	or	a, c
	jr	Z, gsinit_next
	ld	de, #s__INITIALIZED
	ld	hl, #s__INITIALIZER
	ldir
gsinit_next:

.area   _GSFINAL
	ret


	.area _DATA
_plus:
	.db 0

_datastart::
	.area _DATAFINAL
_dataend::

