set PATH=%PATH%;c:\tools
cd lib\mylib
call make.bat
cd ..\..
cd lib\arkostrackerlib
call make.bat
cd ..\..
cd music
AKSToBIN.exe -a 0x08100 game_over.aks game_over.aks.bin
dm -t 1 -l game_over_aks_bin game_over.aks.bin game_over_aks_bin.h 
cd ..

sdcc -c --verbose -V --nostdlib --opt-code-speed --nostdinc --no-std-crt0 -mz80 -DDISC=1 -I lib/mylib -l lib/mylib/mylib.lib -I lib/arkostrackerlib -l lib/arkostrackerlib/arkostrackerlib.lib mustest2.c 
if %ERRORLEVEL% NEQ 0 goto :error
sdldz80 -f custom_mus2.lk
hex2bin mustest2.ihx

FOR /F "delims=" %%i IN ('getlabel _game_over_aks_bin mustest2.noi') DO set OFFSET=%%i
FOR /F "delims=" %%i IN ('getlabel init mustest2.noi') DO set START=%%i
Echo %OFFSET%
Echo %START%

music\AKSToBIN.exe -a 0x08100 music\game_over.aks music\game_over.aks.bin
inject -o %OFFSET% -s %START% -i music\game_over.aks.bin mustest2.bin mustest2.bin

addhead -s 0x200 -x 0x200 mustest2.bin mustest2.bin

cpcxfs -f -nD mustest2.dsk
cpcxfs mustest2.dsk -f -b -p mustest2.bin mustest2

:error