
#include "mylib.h"
#include "ArkosPlayer.h"

#include "music/game_over_aks_bin.h"

/***************************************************************/

void interrupt_handler(void) __critical __interrupt(1) 
{
	if (cpc_InVsync())
	{
    ArkosPlayer_Play();
	}
}


/***************************************************************/

void stop_arkos_music()
{
	cpc_DisableMaskableInterrupts();

	/* stop the sound */
	ArkosPlayer_Stop();
  
  cpc_EnableMaskableInterrupts();
}

/***************************************************************/

void set_arkos_music(unsigned short issfx, const unsigned char *current_sound)
{
	issfx;
	
  cpc_DisableMaskableInterrupts();
  
  /* stop the sound */
	ArkosPlayer_Stop();
  
  ArkosPlayer_Init(current_sound); 
	
	/* enable it */
	cpc_EnableMaskableInterrupts();
}

/***************************************************************/


void play_sfx(unsigned char *current_sound)
{
	current_sound;
	
//	if (SoundMode==SOUND_SFX)
	{
//		set_arkos_music(1,current_sound);
//		while (!starkos_has_music_looped())
//		{
//			wait_vsync();
//		}
	}
}

/*-------------------------------------------------------------------------------*/
/* main game */
void main()
{
	DEBUG_BREAK;

	cpc_MoveMem(game_over_aks_bin, 0x08100, sizeof(game_over_aks_bin));
	
	cpc_DisableMaskableInterrupts();
	cpc_InstallIM1Interrupt(interrupt_handler);
	cpc_EnableMaskableInterrupts();

  set_arkos_music(1, 0x08100);
	
  
  while (1==1)
  {
      cpc_WaitVsyncStart();
    cpc_WaitVsyncEnd();
    
    
    
  }
  
}
	
/*-------------------------------------------------------------------------------*/
/* EOF */