.module _cpc_InstallFastTicker
.globl _cpc_InstallFastTicker

KL_NEW_FAST_TICKER=0x0bce0
KL_L_ROM_ENABLE=0x0b906
KL_L_ROM_DISABLE=0x0b909

.area _CODE

_cpc_InstallFastTicker:
ld hl,#2
add hl,sp
ld e,(hl)
inc hl
ld d,(hl)     ;; function to execute
ld (event_ft_jp+1),de
ld a,#0xcd
ld (event_ft_jp_start),a
ld (event_ft_jp),a
ld a,#0xc3
ld (event_ft_jp_end),a
ld hl,#KL_L_ROM_ENABLE
ld (event_ft_jp_end+1),hl
ld hl,#KL_L_ROM_DISABLE
ld (event_ft_jp_start+1),hl

ld de,#event_ft_jp_start
ld hl,#event_ft_block
ld b,#0x081     ;; asynchronous, near address
ld c,#0       ;; rom select
jp KL_NEW_FAST_TICKER


;; in order to get this in the correct place.
;; ensure data is within main 32k
.area _DATA
event_ft_jp_start:
.ds 3
event_ft_jp:
.ds 3
event_ft_jp_end:
.ds 3

event_ft_block:
.ds 10

