.module _cpc_DrawVerticalLine
.globl __cpc_DrawVerticalLine

;;---------------------------------------------------------------------------------------------------------------------------------
.area _CODE

;; x coordinate
;; y coordinate
;; height

_cpc_DrawVerticalLine: 
	ld ix,#2
	add ix,sp
	
	ld e,(ix+0)		;; x coordinate
	ld d,(ix+1)
	srl d
	rr e			;; /2 for mode 0
	
	ld l,(ix+2)		;; y coordinate
	ld h,(ix+3)
	call _cpc_GetScrAddrInternal
	
	;; height
	ld c,(ix+4)
	ld b,(ix+5)
	
	;; HL = screen coordinate

	;; get pen to write (solid)
	ld a,(_cpc_EncodedPen)
	
	;; X coordinate lower byte
	bit 0,(ix+0)
	;; 0 means left pixel, 1 means right pixel
	ld d,#0xaa
	jr z,dvl2
	;; right pixel
	ld d,#0x55
dvl2:
and d		;; A = pixel to keep
ld e,a

rrc d

dvl1:
ld a,(hl)
and d
or e
ld (hl),a
call _cpc_NextLineInternal
dec bc
ld a,b
or c
jr nz,dvl1
ret



;;---------------------------------------------------------------------------------------------------------------------------------
