.module _cpc_TestKeyCode
.globl _cpc_TestKeyCode
.globl _cpc_LineMask

.area _CODE

;; Keycode
_cpc_TestKeyCode:
	ld	hl,#2
	add	hl,sp
	ld a,(hl)
	rrca
	rrca
	rrca
	and #0x0f
	ld d,a			;; line
	
	ld a,(hl)
	and #0x07
	add a,#<_cpc_LineMask
	ld l,a
	ld a,#>_cpc_LineMask
	adc a,#0
	ld h,a
	ld e,(hl)		;; gets the mask
	
	ld bc,#_cpc_KeyMap
	ld l,d
	ld h,#0
	add hl,bc
	ld a,(hl)
	xor e			;; mask value (turning 0 to 1 if pressed)
	and e			;; isolate value
	ld l,a			;; load into hl for return value
	ld h,#0		
	ret
	