.module _plus_GetAnalogueJoystickAsDigital
.globl _plus_GetAnalogueJoystickAsDigital

.area _CODE

ANALOGUE_MAX=0x3f
ANALOGUE_RANGE=4

_plus_GetAnalogueJoystickAsDigital:
ld hl,#2
add hl,sp
ld a,(hl)
and #1
add a,a
add a,#8
ld l,a
ld h,#0x68
push bc
ld c,#0

;; when moving left and releasing it can sometimes report up/down
ld a,(hl)
cp #ANALOGUE_RANGE
jr nc,pgad1
set 0,c		;; left
jr pgad2

pgad1:
cp #ANALOGUE_MAX-ANALOGUE_RANGE
jr c,pgad2
set 1,c		;; right

pgad2:
inc l
ld a,(hl)
cp #ANALOGUE_RANGE
jr nc,pgad3
set 2,c		;; up
jr pgad4

pgad3:
cp #ANALOGUE_MAX-ANALOGUE_RANGE
jr c,pgad4
set 3,c		;; down
pgad4:
ld l,c
ld h,#0
pop bc
ret
